<script setup>
import { ref, onMounted, computed } from 'vue';
import { useLiveQuotesStore } from '../stores/liveQuotes';
import { queryInfoUrl, queryHoldingsUrl } from '../lib/CoinfolioAPI';

import { enhanceHoldingsResult } from '../lib/CoinfolioPerformance';

let liveQuotesStore = useLiveQuotesStore();

let holdings = ref([]);
let title = ref(String);
let isClosed = ref(Boolean);

let overalls = {
    paid: 0,
    profit: 0,
    profitPercent: 0,
    isProfitPositive: false,
};

let props = defineProps({
    coinfolioId: {
        type: String,
        required: true,
    },
    ownerToken: {
        type: String,
        required: true,
    }
});

onMounted(async () => {
    const authData = JSON.stringify({ coinfolioId: props.coinfolioId, ownerToken: props.ownerToken });
    let infoRes = await fetch(queryInfoUrl, {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
        },
        body: authData,
    });

    if (infoRes.status != 200) {
        alert("failed info request");
        return;
    }

    const infoJson = await infoRes.json();
    title.value = infoJson.title;
    isClosed.value = infoJson.isClosed;


    let res = await fetch(queryHoldingsUrl, {
        method: "POST",
        headers: {
            "Content-Type": "application/json",
        },
        body: authData,
    });

    if (res.status != 200) {
        alert("failed to fetch holdings for coinfolio=" + props.coinfolioId);
        return;
    }

    let holdingsData = await res.json();

    const result = enhanceHoldingsResult(holdingsData, liveQuotesStore);
    holdings.value = result.holdings;
    overalls = result.overalls;
});

function currencyFormat(value) {
    if(isNaN(value)) {
        return "-";
    }

    let absValue = Math.abs(value);
    let minimumFractionDigits = 2;
    if(absValue < 1) {
        minimumFractionDigits = 4;
    }
    if(absValue < 0.0001) {
        minimumFractionDigits = 8;
    }

    return new Intl.NumberFormat('de-DE', { style: "currency", currency: "EUR", minimumFractionDigits}).format(value);
}

function numberFormat(value) {
    if(isNaN(value)) {
        return "-";
    }
    return new Intl.NumberFormat('de-DE').format(value);
}

function removeCoinFolio() {
    var result = window.confirm("Really remove CoinFolio? Make sure you have backed up the CoinFolioId and OwnerToken!");

    if(result) {
        var coinfolios = JSON.parse(window.localStorage.getItem("coinfolios"));
        coinfolios = coinfolios.filter((c) => c.id != props.coinfolioId);
        window.localStorage.setItem("coinfolios", JSON.stringify(coinfolios));

        window.location.reload();
    }
}
</script>

<template>
    <h4>{{ title }} <span class="fs-6 text-secondary">({{ props.coinfolioId }})</span></h4>
    <div v-if="holdings.length == 0">
        Empty coinfolio, add a transaction!
    </div>
    <table v-else class="table">
        <thead>
            <tr>
                <th>Coin</th>
                <th>Holdings</th>
                <th>UnitValue</th>
                <th>TotalValue</th>
                <th>TotalPaid</th>
                <th>Profit</th>
                <th>Pofit %</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="h of holdings">
                <td>
                    {{ h.currency.name }}
                </td>
                <td>
                    {{ numberFormat(h.amount) }} {{ h.currency.tickerSymbol }}
                </td>
                <td v-if="liveQuotesStore.loaded">
                    <span v-if="isNaN(h.currentValue)" style="cursor: help;" title="No current value provided. Probably delisted.">MISSING</span>
                    <span v-else>{{  currencyFormat(h.currentValue) }}</span>
                </td>
                <td v-else>
                    Loading...
                </td>
                <td v-if="liveQuotesStore.loaded">
                    {{ currencyFormat(h.totalValue) }}
                </td>
                <td v-else>
                    Loading...
                </td>
                <td>
                    {{ currencyFormat(h.totalPaid) }}
                </td>
                <td class="fw-bold" :class="{ 'text-success': h.totalProfitPositive, 'text-danger': !h.totalProfitPositive }">
                    {{ currencyFormat(h.totalProfit) }}
                </td>
                <td class="fw-bold" :class="{ 'text-success': h.totalProfitPositive, 'text-danger': !h.totalProfitPositive }">
                    {{ isNaN(h.totalProfitPercent) ? "-" : numberFormat(h.totalProfitPercent) + '%' }}
                </td>
                <td>
                    <RouterLink
                        :to="{ name: 'view-transactions', params: { coinfolioId: props.coinfolioId, ownerToken: props.ownerToken, currency: h.currency.tickerSymbol } }"
                        custom v-slot="{ navigate }">
                        <a href="#" class="btn btn-sm btn-secondary" title="Details" @click="navigate"><i class="bi bi-info-circle"></i></a>
                    </RouterLink>
                </td>
            </tr>
            <tr style="background-color: #EEE;">
                <td colspan="4" class="text-end fw-bold">Overall Totals:</td>
                <td class="fw-bold">{{ currencyFormat(overalls.paid) }}</td>
                <td class="fw-bold" :class="{ 'text-success': overalls.isProfitPositive.value, 'text-danger': !overalls.isProfitPositive.value }">{{ currencyFormat(overalls.profit.value) }}</td>
                <td class="fw-bold" :class="{ 'text-success': overalls.isProfitPositive.value, 'text-danger': !overalls.isProfitPositive.value }">{{ numberFormat(overalls.profitPercent.value) }}%</td>
                <td></td>
            </tr>
        </tbody>
    </table>
    <div class="btn-group">
        <RouterLink
            :to="{ name: 'record-transaction', params: { coinfolioId: props.coinfolioId, ownerToken: props.ownerToken } }"
            custom v-slot="{ navigate }">
            <button class="btn btn-sm btn-success" @click="navigate" role="link">Record Transaction</button>
        </RouterLink>
        <button class="btn btn-sm btn-danger" @click="removeCoinFolio">Remove CoinFolio</button>
</div>
</template>